let eventHelper;
class EventHelper {
  constructor() {
    /**
     * listener has表
     * {
     *  instance: {
     *              eventName: [...handlers]
     *            }
     * }
     */
    this._listener = new Map();
  }

  addListener(instance, eventName, handler, context) {
    if (!BMapGL) throw new Error('please wait for Map API load');
    // let listener = BMapGL.event.addListener(instance, eventName, handler, context);
    instance.on(eventName, handler, context);
    if (!this._listener.get(instance)) this._listener.set(instance, {});
    let listenerMap = this._listener.get(instance);
    if (!listenerMap[eventName]) listenerMap[eventName] = [];
    listenerMap[eventName].push(handler);

  }

  removeListener(instance, eventName, handler) {
    if (!BMapGL) throw new Error('please wait for Map API load');
    if (!this._listener.get(instance) || !this._listener.get(instance)[eventName]) return;
    let listenerArr = this._listener.get(instance)[eventName];
    if (handler) {
      let l_index = listenerArr.indexOf(handler);
      instance.removeEventListener(eventName, listenerArr[l_index]);
      listenerArr.splice(l_index, 1);
    } else {
      listenerArr.forEach(listener => {
        instance.removeEventListener(eventName, listener);
      });
      this._listener.get(instance)[eventName] = [];
    }
  }
  addListenerOnce(instance, eventName, handler, context) {
    return instance.on(eventName, handler, context, true);
  }
  trigger(instance, eventName, args) {
    return instance.emit(eventName, args);
  }

  clearListeners(instance) {
    let listeners = this._listener.get(instance);
    if (!listeners) return;
    Object.keys(listeners).map(eventName => {
      let funcs = listeners[eventName];
      funcs.forEach(func => {
        instance.removeEventListener(eventName, func);
      });

    });
  }
};

eventHelper = eventHelper || new EventHelper();

export default eventHelper;
